#ifndef RENDERER_H_
#define RENDERER_H_

#include <vector>
#include "metascene.h"

enum {
	RENDER_MIRRORS	= 1,

	RENDER_ALL		= 0x7fffffff
};

class Renderer {
private:
	MetaScene *mscn;
	unsigned int *shaders;

public:
	unsigned int ropt;

	Renderer();
	virtual ~Renderer();

	virtual bool init();
	virtual void destroy();

	virtual void set_scene(MetaScene *mscn);
	virtual MetaScene *get_scene() const;

	virtual void draw() const;
	virtual void draw_object(Object *obj) const;

	virtual void draw_mirror(FlatMirror *mir) const;
};

#endif	// RENDERER_H_
